package Text::Bidi;

# taken from fribidi_tab_mirroring.i
our %Mirrored = (
  "\x{0028}" => "\x{0029}",
  "\x{0029}" => "\x{0028}",
  "\x{003C}" => "\x{003E}",
  "\x{003E}" => "\x{003C}",
  "\x{005B}" => "\x{005D}",
  "\x{005D}" => "\x{005B}",
  "\x{007B}" => "\x{007D}",
  "\x{007D}" => "\x{007B}",
  "\x{00AB}" => "\x{00BB}",
  "\x{00BB}" => "\x{00AB}",
  "\x{2039}" => "\x{203A}",
  "\x{203A}" => "\x{2039}",
  "\x{2045}" => "\x{2046}",
  "\x{2046}" => "\x{2045}",
  "\x{207D}" => "\x{207E}",
  "\x{207E}" => "\x{207D}",
  "\x{208D}" => "\x{208E}",
  "\x{208E}" => "\x{208D}",
  "\x{2208}" => "\x{220B}",
  "\x{2209}" => "\x{220C}",
  "\x{220A}" => "\x{220D}",
  "\x{220B}" => "\x{2208}",
  "\x{220C}" => "\x{2209}",
  "\x{220D}" => "\x{220A}",
  "\x{2215}" => "\x{29F5}",
  "\x{223C}" => "\x{223D}",
  "\x{223D}" => "\x{223C}",
  "\x{2243}" => "\x{22CD}",
  "\x{2252}" => "\x{2253}",
  "\x{2253}" => "\x{2252}",
  "\x{2254}" => "\x{2255}",
  "\x{2255}" => "\x{2254}",
  "\x{2264}" => "\x{2265}",
  "\x{2265}" => "\x{2264}",
  "\x{2266}" => "\x{2267}",
  "\x{2267}" => "\x{2266}",
  "\x{2268}" => "\x{2269}",
  "\x{2269}" => "\x{2268}",
  "\x{226A}" => "\x{226B}",
  "\x{226B}" => "\x{226A}",
  "\x{226E}" => "\x{226F}",
  "\x{226F}" => "\x{226E}",
  "\x{2270}" => "\x{2271}",
  "\x{2271}" => "\x{2270}",
  "\x{2272}" => "\x{2273}",
  "\x{2273}" => "\x{2272}",
  "\x{2274}" => "\x{2275}",
  "\x{2275}" => "\x{2274}",
  "\x{2276}" => "\x{2277}",
  "\x{2277}" => "\x{2276}",
  "\x{2278}" => "\x{2279}",
  "\x{2279}" => "\x{2278}",
  "\x{227A}" => "\x{227B}",
  "\x{227B}" => "\x{227A}",
  "\x{227C}" => "\x{227D}",
  "\x{227D}" => "\x{227C}",
  "\x{227E}" => "\x{227F}",
  "\x{227F}" => "\x{227E}",
  "\x{2280}" => "\x{2281}",
  "\x{2281}" => "\x{2280}",
  "\x{2282}" => "\x{2283}",
  "\x{2283}" => "\x{2282}",
  "\x{2284}" => "\x{2285}",
  "\x{2285}" => "\x{2284}",
  "\x{2286}" => "\x{2287}",
  "\x{2287}" => "\x{2286}",
  "\x{2288}" => "\x{2289}",
  "\x{2289}" => "\x{2288}",
  "\x{228A}" => "\x{228B}",
  "\x{228B}" => "\x{228A}",
  "\x{228F}" => "\x{2290}",
  "\x{2290}" => "\x{228F}",
  "\x{2291}" => "\x{2292}",
  "\x{2292}" => "\x{2291}",
  "\x{2298}" => "\x{29B8}",
  "\x{22A2}" => "\x{22A3}",
  "\x{22A3}" => "\x{22A2}",
  "\x{22A6}" => "\x{2ADE}",
  "\x{22A8}" => "\x{2AE4}",
  "\x{22A9}" => "\x{2AE3}",
  "\x{22AB}" => "\x{2AE5}",
  "\x{22B0}" => "\x{22B1}",
  "\x{22B1}" => "\x{22B0}",
  "\x{22B2}" => "\x{22B3}",
  "\x{22B3}" => "\x{22B2}",
  "\x{22B4}" => "\x{22B5}",
  "\x{22B5}" => "\x{22B4}",
  "\x{22B6}" => "\x{22B7}",
  "\x{22B7}" => "\x{22B6}",
  "\x{22C9}" => "\x{22CA}",
  "\x{22CA}" => "\x{22C9}",
  "\x{22CB}" => "\x{22CC}",
  "\x{22CC}" => "\x{22CB}",
  "\x{22CD}" => "\x{2243}",
  "\x{22D0}" => "\x{22D1}",
  "\x{22D1}" => "\x{22D0}",
  "\x{22D6}" => "\x{22D7}",
  "\x{22D7}" => "\x{22D6}",
  "\x{22D8}" => "\x{22D9}",
  "\x{22D9}" => "\x{22D8}",
  "\x{22DA}" => "\x{22DB}",
  "\x{22DB}" => "\x{22DA}",
  "\x{22DC}" => "\x{22DD}",
  "\x{22DD}" => "\x{22DC}",
  "\x{22DE}" => "\x{22DF}",
  "\x{22DF}" => "\x{22DE}",
  "\x{22E0}" => "\x{22E1}",
  "\x{22E1}" => "\x{22E0}",
  "\x{22E2}" => "\x{22E3}",
  "\x{22E3}" => "\x{22E2}",
  "\x{22E4}" => "\x{22E5}",
  "\x{22E5}" => "\x{22E4}",
  "\x{22E6}" => "\x{22E7}",
  "\x{22E7}" => "\x{22E6}",
  "\x{22E8}" => "\x{22E9}",
  "\x{22E9}" => "\x{22E8}",
  "\x{22EA}" => "\x{22EB}",
  "\x{22EB}" => "\x{22EA}",
  "\x{22EC}" => "\x{22ED}",
  "\x{22ED}" => "\x{22EC}",
  "\x{22F0}" => "\x{22F1}",
  "\x{22F1}" => "\x{22F0}",
  "\x{22F2}" => "\x{22FA}",
  "\x{22F3}" => "\x{22FB}",
  "\x{22F4}" => "\x{22FC}",
  "\x{22F6}" => "\x{22FD}",
  "\x{22F7}" => "\x{22FE}",
  "\x{22FA}" => "\x{22F2}",
  "\x{22FB}" => "\x{22F3}",
  "\x{22FC}" => "\x{22F4}",
  "\x{22FD}" => "\x{22F6}",
  "\x{22FE}" => "\x{22F7}",
  "\x{2308}" => "\x{2309}",
  "\x{2309}" => "\x{2308}",
  "\x{230A}" => "\x{230B}",
  "\x{230B}" => "\x{230A}",
  "\x{2329}" => "\x{232A}",
  "\x{232A}" => "\x{2329}",
  "\x{2768}" => "\x{2769}",
  "\x{2769}" => "\x{2768}",
  "\x{276A}" => "\x{276B}",
  "\x{276B}" => "\x{276A}",
  "\x{276C}" => "\x{276D}",
  "\x{276D}" => "\x{276C}",
  "\x{276E}" => "\x{276F}",
  "\x{276F}" => "\x{276E}",
  "\x{2770}" => "\x{2771}",
  "\x{2771}" => "\x{2770}",
  "\x{2772}" => "\x{2773}",
  "\x{2773}" => "\x{2772}",
  "\x{2774}" => "\x{2775}",
  "\x{2775}" => "\x{2774}",
  "\x{27D5}" => "\x{27D6}",
  "\x{27D6}" => "\x{27D5}",
  "\x{27DD}" => "\x{27DE}",
  "\x{27DE}" => "\x{27DD}",
  "\x{27E2}" => "\x{27E3}",
  "\x{27E3}" => "\x{27E2}",
  "\x{27E4}" => "\x{27E5}",
  "\x{27E5}" => "\x{27E4}",
  "\x{27E6}" => "\x{27E7}",
  "\x{27E7}" => "\x{27E6}",
  "\x{27E8}" => "\x{27E9}",
  "\x{27E9}" => "\x{27E8}",
  "\x{27EA}" => "\x{27EB}",
  "\x{27EB}" => "\x{27EA}",
  "\x{2983}" => "\x{2984}",
  "\x{2984}" => "\x{2983}",
  "\x{2985}" => "\x{2986}",
  "\x{2986}" => "\x{2985}",
  "\x{2987}" => "\x{2988}",
  "\x{2988}" => "\x{2987}",
  "\x{2989}" => "\x{298A}",
  "\x{298A}" => "\x{2989}",
  "\x{298B}" => "\x{298C}",
  "\x{298C}" => "\x{298B}",
  "\x{298D}" => "\x{2990}",
  "\x{298E}" => "\x{298F}",
  "\x{298F}" => "\x{298E}",
  "\x{2990}" => "\x{298D}",
  "\x{2991}" => "\x{2992}",
  "\x{2992}" => "\x{2991}",
  "\x{2993}" => "\x{2994}",
  "\x{2994}" => "\x{2993}",
  "\x{2995}" => "\x{2996}",
  "\x{2996}" => "\x{2995}",
  "\x{2997}" => "\x{2998}",
  "\x{2998}" => "\x{2997}",
  "\x{29B8}" => "\x{2298}",
  "\x{29C0}" => "\x{29C1}",
  "\x{29C1}" => "\x{29C0}",
  "\x{29C4}" => "\x{29C5}",
  "\x{29C5}" => "\x{29C4}",
  "\x{29CF}" => "\x{29D0}",
  "\x{29D0}" => "\x{29CF}",
  "\x{29D1}" => "\x{29D2}",
  "\x{29D2}" => "\x{29D1}",
  "\x{29D4}" => "\x{29D5}",
  "\x{29D5}" => "\x{29D4}",
  "\x{29D8}" => "\x{29D9}",
  "\x{29D9}" => "\x{29D8}",
  "\x{29DA}" => "\x{29DB}",
  "\x{29DB}" => "\x{29DA}",
  "\x{29F5}" => "\x{2215}",
  "\x{29F8}" => "\x{29F9}",
  "\x{29F9}" => "\x{29F8}",
  "\x{29FC}" => "\x{29FD}",
  "\x{29FD}" => "\x{29FC}",
  "\x{2A2B}" => "\x{2A2C}",
  "\x{2A2C}" => "\x{2A2D}",
  "\x{2A2D}" => "\x{2A2E}",
  "\x{2A2E}" => "\x{2A2D}",
  "\x{2A34}" => "\x{2A35}",
  "\x{2A35}" => "\x{2A34}",
  "\x{2A3C}" => "\x{2A3D}",
  "\x{2A3D}" => "\x{2A3C}",
  "\x{2A64}" => "\x{2A65}",
  "\x{2A65}" => "\x{2A64}",
  "\x{2A79}" => "\x{2A7A}",
  "\x{2A7A}" => "\x{2A79}",
  "\x{2A7D}" => "\x{2A7E}",
  "\x{2A7E}" => "\x{2A7D}",
  "\x{2A7F}" => "\x{2A80}",
  "\x{2A80}" => "\x{2A7F}",
  "\x{2A81}" => "\x{2A82}",
  "\x{2A82}" => "\x{2A81}",
  "\x{2A83}" => "\x{2A84}",
  "\x{2A84}" => "\x{2A83}",
  "\x{2A8B}" => "\x{2A8C}",
  "\x{2A8C}" => "\x{2A8B}",
  "\x{2A91}" => "\x{2A92}",
  "\x{2A92}" => "\x{2A91}",
  "\x{2A93}" => "\x{2A94}",
  "\x{2A94}" => "\x{2A93}",
  "\x{2A95}" => "\x{2A96}",
  "\x{2A96}" => "\x{2A95}",
  "\x{2A97}" => "\x{2A98}",
  "\x{2A98}" => "\x{2A97}",
  "\x{2A99}" => "\x{2A9A}",
  "\x{2A9A}" => "\x{2A99}",
  "\x{2A9B}" => "\x{2A9C}",
  "\x{2A9C}" => "\x{2A9B}",
  "\x{2AA1}" => "\x{2AA2}",
  "\x{2AA2}" => "\x{2AA1}",
  "\x{2AA6}" => "\x{2AA7}",
  "\x{2AA7}" => "\x{2AA6}",
  "\x{2AA8}" => "\x{2AA9}",
  "\x{2AA9}" => "\x{2AA8}",
  "\x{2AAA}" => "\x{2AAB}",
  "\x{2AAB}" => "\x{2AAA}",
  "\x{2AAC}" => "\x{2AAD}",
  "\x{2AAD}" => "\x{2AAC}",
  "\x{2AAF}" => "\x{2AB0}",
  "\x{2AB0}" => "\x{2AAF}",
  "\x{2AB3}" => "\x{2AB4}",
  "\x{2AB4}" => "\x{2AB3}",
  "\x{2ABB}" => "\x{2ABC}",
  "\x{2ABC}" => "\x{2ABB}",
  "\x{2ABD}" => "\x{2ABE}",
  "\x{2ABE}" => "\x{2ABD}",
  "\x{2ABF}" => "\x{2AC0}",
  "\x{2AC0}" => "\x{2ABF}",
  "\x{2AC1}" => "\x{2AC2}",
  "\x{2AC2}" => "\x{2AC1}",
  "\x{2AC3}" => "\x{2AC4}",
  "\x{2AC4}" => "\x{2AC3}",
  "\x{2AC5}" => "\x{2AC6}",
  "\x{2AC6}" => "\x{2AC5}",
  "\x{2ACD}" => "\x{2ACE}",
  "\x{2ACE}" => "\x{2ACD}",
  "\x{2ACF}" => "\x{2AD0}",
  "\x{2AD0}" => "\x{2ACF}",
  "\x{2AD1}" => "\x{2AD2}",
  "\x{2AD2}" => "\x{2AD1}",
  "\x{2AD3}" => "\x{2AD4}",
  "\x{2AD4}" => "\x{2AD3}",
  "\x{2AD5}" => "\x{2AD6}",
  "\x{2AD6}" => "\x{2AD5}",
  "\x{2ADE}" => "\x{22A6}",
  "\x{2AE3}" => "\x{22A9}",
  "\x{2AE4}" => "\x{22A8}",
  "\x{2AE5}" => "\x{22AB}",
  "\x{2AEC}" => "\x{2AED}",
  "\x{2AED}" => "\x{2AEC}",
  "\x{2AF7}" => "\x{2AF8}",
  "\x{2AF8}" => "\x{2AF7}",
  "\x{2AF9}" => "\x{2AFA}",
  "\x{2AFA}" => "\x{2AF9}",
  "\x{3008}" => "\x{3009}",
  "\x{3009}" => "\x{3008}",
  "\x{300A}" => "\x{300B}",
  "\x{300B}" => "\x{300A}",
  "\x{300C}" => "\x{300D}",
  "\x{300D}" => "\x{300C}",
  "\x{300E}" => "\x{300F}",
  "\x{300F}" => "\x{300E}",
  "\x{3010}" => "\x{3011}",
  "\x{3011}" => "\x{3010}",
  "\x{3014}" => "\x{3015}",
  "\x{3015}" => "\x{3014}",
  "\x{3016}" => "\x{3017}",
  "\x{3017}" => "\x{3016}",
  "\x{3018}" => "\x{3019}",
  "\x{3019}" => "\x{3018}",
  "\x{301A}" => "\x{301B}",
  "\x{301B}" => "\x{301A}",
  "\x{FF08}" => "\x{FF09}",
  "\x{FF09}" => "\x{FF08}",
  "\x{FF1C}" => "\x{FF1E}",
  "\x{FF1E}" => "\x{FF1C}",
  "\x{FF3B}" => "\x{FF3D}",
  "\x{FF3D}" => "\x{FF3B}",
  "\x{FF5B}" => "\x{FF5D}",
  "\x{FF5D}" => "\x{FF5B}",
  "\x{FF5F}" => "\x{FF60}",
  "\x{FF60}" => "\x{FF5F}",
  "\x{FF62}" => "\x{FF63}",
  "\x{FF63}" => "\x{FF62}",
);

our $Mirrored = join('', keys %Mirrored);
$Mirrored = qr/[\Q$Mirrored\E]/o;

